VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Subclassing ""Notepad"" using ""dssubcls.dll""     (c) by Delphin Software"
   ClientHeight    =   3225
   ClientLeft      =   4095
   ClientTop       =   4260
   ClientWidth     =   6765
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3225
   ScaleWidth      =   6765
   Begin VB.ListBox List1 
      Height          =   2595
      Left            =   5580
      TabIndex        =   6
      Top             =   450
      Width           =   1005
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Subclass Edit window "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Index           =   1
      Left            =   360
      TabIndex        =   5
      Top             =   2790
      Width           =   2175
   End
   Begin VB.OptionButton Option1 
      Caption         =   "Subclass Notepad"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Index           =   0
      Left            =   360
      TabIndex        =   4
      Top             =   2520
      Width           =   2355
   End
   Begin VB.TextBox Text1 
      Height          =   2610
      Left            =   2970
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   450
      Width           =   2355
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Subclass the window  procedure of Notepad"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   690
      Left            =   360
      TabIndex        =   2
      Top             =   1665
      Width           =   2310
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Change style of the ""Edit"" window"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   645
      Left            =   360
      TabIndex        =   1
      Top             =   945
      Width           =   2310
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Launch Notepad"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   360
      TabIndex        =   0
      Top             =   270
      Width           =   2310
   End
   Begin VB.Label Label1 
      Caption         =   "Entered Text:                                    Messages:"
      Height          =   240
      Left            =   3015
      TabIndex        =   7
      Top             =   225
      Width           =   3435
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************************************
'     Sample for subclassing a foreign application by use of the "dssubcls.dll"
'                      (c) 2002 by J. Thuemmler, Delphin Software.
'****************************************************************************************
Option Explicit
'****************************************************************************************
Private Const Links& = 20
Private Const Oben& = 20
Private Const Hoch& = 300
'------------------------------------
Private hnote&, hedit&
Private Breit&, tpx&, tpy&
'****************************************************************************************
Private Sub Command1_Click()  '# Launch Notepad
  Command1.Enabled = False
  Command2.Enabled = True
  Command3.Enabled = True
  
  '# Launch Notepad invisible
  Call Shell("notepad", 0)
  hnote = FindWindow("notepad", vbNullString)
  hedit = FindWindowEx(hnote, 0, "edit", vbNullString)
  'Debug.Print hnote, hedit
  
  '# Position and show Notepad
  Call SetWindowPos(hnote, 0, Links, Oben, Breit, Hoch, SWP_SHOWWINDOW)
End Sub

'****************************************************************************************
Private Sub Command2_Click()        '# Change window style
  Command2.Enabled = False
  Command3.Enabled = False
  
  '# Change the window style of Notepads Child Window (Edit):
  '# Enable sizing and disable input of characters (only numbers)
  Call SubClass(hedit, 0, 0, WS_THICKFRAME Or ES_NUMBER)
  Call SetWindowPos(hedit, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED)
  
  '# Remove the Notepads title bar:
  'Call SubClass(hnote, 0, WS_CAPTION)
  'Call SetWindowPos(hnote, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_FRAMECHANGED)
  
End Sub

'****************************************************************************************
Private Sub Command3_Click()        '# Subclass window procedure
  Command2.Enabled = False
  Command3.Enabled = False
  
  If Option1(0) Then                '# Notepad itself
    '# Switch on the "listening" of messages for Notepad itself;
    '# the messages will be received in "Callback" of
    '# "modSubClass" and monitored in the listbox.
    If IsWindow(hnote) Then
      Call SubClass(hnote, AddressOf Callback, 0, 0, 0, 1)
      Call UseSendMessage(1)        '# Enable suppressing or modifying messages
    End If
  ElseIf Option1(1) Then            '# Edit window (child)
    '# Switch on the "listening" of messages for the edit class window of Notepad;
    '# the entered text will be displayed in the textbox.
    If IsWindow(hedit) Then
      Call SubClass(hedit, AddressOf Callback, 0, 0, 0, 1)
      Call SetForegroundWindow(hnote)
    End If
  End If
  
End Sub

'****************************************************************************************
Private Sub Form_Load()
  With Screen
    tpx = .TwipsPerPixelX: tpy = .TwipsPerPixelY
  End With

neu:
  hnote = FindWindow("notepad", vbNullString)
  If IsWindow(hnote) Then
    Call SetForegroundWindow(hnote)
    MsgBox "Please at first close Notepad" & vbCrLf & _
    "    and than click on ""OK""", 64, " NOTE:"
    GoTo neu
  End If
  
  hnote = 0
  Command2.Enabled = False
  Command3.Enabled = False
  Option1(1) = 1
  
  Breit = Width \ tpy
  Top = (Oben + Hoch + 1) * tpy
  Left = Links * tpx
End Sub

'****************************************************************************************
Private Sub Form_Unload(Cancel As Integer)
  '# Optional, but good style; the DLL watches closing your app
  '# and restores the original window procedure if necessary.
  Call SubClass(0)
End Sub

'****************************************************************************************
'# Display the text written in Notepad
Sub DisplayText(ByVal wp&)
Static Text$
With Text1
  Text = .Text & Chr$(wp)
  .Text = Text
End With
End Sub

'****************************************************************************************
'# Display the messages of Notepad
Sub DisplayMessage(ByVal msg&)
Static z%
With List1
  z = z + 1
  If z = 1000 Then z = 0: .Clear
  .AddItem " &H" & Hex(msg), 0
End With
End Sub

'****************************************************************************************

