Attribute VB_Name = "modSubClass"
'******************************************************************************************
'     Sample for subclassing a foreign application by use of the "dssubcls.dll"
'                      (c) 2002 by J. Thuemmler, Delphin Software.
'******************************************************************************************
Option Explicit
'******************************************************************************************
'# This function is called from the DLL passing the parameters of the original messages,
'# but NOT for messages below WM_USER which use pointers.
'# To get all messages, you must call "UseSendMessage 1".
'# To be able to suppress or modify messages, you must call "UseSendMessage 1" first.
Public Function Callback&(ByVal wMsg&, ByVal wParam&, ByVal lParam&)

  '# Display the messages of Notepad
  Call Form1.DisplayMessage(wMsg)
  
  Select Case wMsg
    '-------------------------------------------------------------------
    '# These calls disable the system menu and menu functions of Notepad
    Case WM_CLOSE:      Call SetParams             '# = suppress message
    Case WM_COMMAND:    Call SetParams             '# = suppress message
    Case WM_SYSCOMMAND: Call SetParams             '# = suppress message
    '-------------------------------------------------------------------
    Case WM_CHAR:
      '# Display the text written in Notepad
      Call Form1.DisplayText(wParam)
    Case WM_KEYDOWN:        Debug.Print "KeyDown"
      '# Code for evaluating messages
    Case WM_KEYUP:          Debug.Print "KeyUp"
      '# Code for evaluating messages
    Case WM_LBUTTONDOWN:    Debug.Print "LeftDown"
      '# Code for evaluating messages
    Case WM_LBUTTONUP:      Debug.Print "LeftUp"
      '# Code for evaluating messages
    Case WM_LBUTTONDBLCLK:  Debug.Print "DblClick"
      '# Code for evaluating messages
    '...
    '...
  End Select
End Function

'******************************************************************************************
